
package de.ivu.elect.business.staat.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.staat.entity.StaatenGruppe;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractStaatenGruppeEdit {

  @Inject
  protected StaatenGruppeDAO dao;

  @Inject
  protected StaatenGruppeExtendedDAO extendedDao;

  public void delete(StaatenGruppe entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(StaatenGruppe entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(StaatenGruppe entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected StaatenGruppe getAttachedEntity(StaatenGruppe entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected StaatenGruppe getAttachedAndRefreshedEntity(StaatenGruppe entity) {
    return dao.refresh(entity);
  }
}
